
-- Phrase variables
BINDING_HEADER_BANKGUI = "BankGUI v2.3"
BINDING_NAME_BANKGUITOGGLE = "Toggle BankGUI Window"

BANKGUI_TABNAME				 = "Bank"
BANKGUI_TITLE				 = "BankGUI"
BANKGUI_GUILD				 = "Guild"
BANKGUI_DELETE				 = "Delete"
BANKGUI_DELETES				 = "Delete Items"

BANKGUI_OWNER				 = "Owner"
BANKGUI_ITEM				 = "Item name"
BANKGUI_AMOUNT				 = "Amount"
BANKGUI_TYPE				 = "Item Type"
BANKGUI_LEVEL				 = "Item Level"
BANKGUI_INVENT				 = "Inventory"
BANKGUI_EQUIP				 = "Equipslot"
BANKGUI_VENDOR				 = "Vendor value"

BANKGUI_GOLD_BANK  = "Total Gold |cffffffff%.2f|r"
BANKGUI_GOLD_GUILD = "Gold |cffffffff%.2f|r"

BANKGUI_HELP = {
	{ BANKGUI_TITLE .." help:", 1, 0.5, 0 },
	{ " Go to Social |cffffff80(O)|r and select the Bank tab at the bottomright of the window.", 0.5, 1, 1 },
	{ " There you see a list of items that are in bags/bank/equiped on all your characters (per account, per realm).", 0.5, 1, 1 },
	{ " |cffffff80NOTE:|r Items only get added/updated to the list when you open your Bank/Tradeskill window.", 0.5, 1, 1 },
	{ " ", 1, 1, 1 },
	{ " |cffffff80/bank|r Shows / Hides the BankGUI window", 1, 1, 1 },
	{ " |cffffff80/bank help|r show help text", 1, 1, 1 },
	{ " |cffffff80/bank update|r Update Currency, Friendlist and Glyphs", 1, 1, 1 },
	{ " |cffffff80/bank detach|r Detach the BankGUI window from the Social pane", 1, 1, 1 },
	{ " |cffffff80/bank attach|r Attach the BankGUI window to the Social pane", 1, 1, 1 },
	{ " |cffffff80/bank sort|r Sort BankGUI items (normally only done when opening bank)", 1, 1, 1 },
	{ " |cffffff80/bank check|r Check for itemstacks that are not maximized (Bags/Bank if opened)", 1, 1, 1 },
	{ " |cffffff80/bank grey|r Check for 'grey' quality items in your Bags (Bank if openend)", 1, 1, 1 },
	{ " ", 1, 1, 1 },
	{ "Hyperlink in Chat windows:", 1, 0.5, 0 },
	{ " |cffffff80Alt-Click|r Put the link text in the Filter textbox", 1, 1, 1 },
	{ " |cffffff80Alt+Shift-Click|r Put the Itemlink in the Farm Item name", 1, 1, 1 },
	{ " ", 1, 1, 1 },
	{ "Hoover over Items:", 1, 0.5, 0 },
	{ " |cffffff80Alt-Hoover|r Put the itemname in the Filter textbox", 1, 1, 1 },
	{ " |cffffff80Alt+Shift-Hoover|r Put the Itemlink in the Farm Item name", 1, 1, 1 },
	{ " ", 1, 1, 1 },
	{ "Sort Order:", 1, 0.5, 0 },
}
-------------------

BANKGUIS_TO_DISPLAY          = 18
FRIENDS_FRAME_BANKGUI_HEIGHT = 16

BANKGUI_TYPE_CURRENCY  = "-8"
BANKGUI_TYPE_FRIENDS   = "-7"
BANKGUI_TYPE_GLYPHS    = "-6"
BANKGUI_TYPE_FARMS     = "-5"
BANKGUI_TYPE_TRADELINK = "-4"


BANKGUI_KEEPTRACKOF = "KeepTrackOf"
BANKGUI_KEEPGUILD   = "Guild Items"
BANKGUI_KEEPITEMS   = "Items"
BANKGUI_KEEPTRADE   = "TradeSkills"
BANKGUI_KEEPPROFS   = "Profession Links"
BANKGUI_KEEPGLYPS   = "Glyphs"
BANKGUI_KEEPFRIEND  = "Friends"
BANKGUI_KEEPCURR    = "Currency"
BANKGUI_SORTTITLE1  = "1st Sort Order"
BANKGUI_SORTTITLE2  = "2nd Sort Order"
BANKGUI_SORTTITLE3  = "3rd Sort Order"
BANKGUI_SORTNAME1   = "Item name"
BANKGUI_SORTNAME2   = "Owner / Player name"
BANKGUI_SORTNAME3   = "Amount"
BANKGUI_SORTNAME4   = "Item Level"
BANKGUI_SORTNAME5   = "None"
BANKGUI_FACTION     = "Show both Factions"
BANKGUI_TOTALS      = "Show only Totals"
BANKGUI_TOOLTIPS    = "Tooltips"
BANKGUI_HOOVER      = "Use 'Shift/Alt' Hoover"
BANKGUI_BANKSKIN    = "BankGUI Skin"
BANKGUI_TRANSPARENT = "Transparent"
BANKGUI_BARCOLOR    = "Bar Color ..."
BANKGUI_BACKCOLOR   = "Background Color ..."
BANKGUI_RESETCOLORS = "Reset Colors"


-- Local variables

local bank_frame_opened = false
local bank_ahopened = false
local bank_tradeskill_name = ""
local bank_tradeskill_prof = ""
local bank_tradeskill_titl = nil
local BankListFL = {}


-- Global variables

BankGUI = {
	chat = DEFAULT_CHAT_FRAME,
	numtab = 99,
	playername = nil,
	guildname = nil,
	realmname = nil,
	playerfaction = nil,
	guildcolor_on = "|cffffffff",
	guildcolor_of = "|cffa0a0a0",
	TypesIndex = 1,
	ClickedIndex = 0,
	isPvpInstance = { ["pvp"] = true, ["arena"] = true },
	agrogained = false,
	Wisp_Data = {},
	BankFilter = {},
	BankTotals = {},
	BankListStock = {},
	BankFactionColors = {},
	BANKGUI_OPTIONS_MENU = {
		[BANKGUI_KEEPTRACKOF] = {
			[BANKGUI_KEEPGUILD] = {},
			[BANKGUI_KEEPITEMS] = {},
			[BANKGUI_KEEPTRADE] = {},
			[BANKGUI_KEEPPROFS] = {},
			[BANKGUI_KEEPGLYPS] = {},
			[BANKGUI_KEEPFRIEND] = {},
			[BANKGUI_KEEPCURR] = {},
		},
		[BANKGUI_SORTTITLE1] = {
			[BANKGUI_SORTNAME1] = {},
			[BANKGUI_SORTNAME2] = {},
			[BANKGUI_SORTNAME3] = {},
			[BANKGUI_SORTNAME4] = {},
			[BANKGUI_SORTNAME5] = {},
		},
		[BANKGUI_SORTTITLE2] = {
			[BANKGUI_SORTNAME1] = {},
			[BANKGUI_SORTNAME2] = {},
			[BANKGUI_SORTNAME3] = {},
			[BANKGUI_SORTNAME4] = {},
			[BANKGUI_SORTNAME5] = {},
		},
		[BANKGUI_SORTTITLE3] = {
			[BANKGUI_SORTNAME1] = {},
			[BANKGUI_SORTNAME2] = {},
			[BANKGUI_SORTNAME3] = {},
			[BANKGUI_SORTNAME4] = {},
			[BANKGUI_SORTNAME5] = {},
		},
		{
			name = BANKGUI_FACTION,
			checkable = true,
			isNotRadio = true,
		},
		{
			name = BANKGUI_TOTALS,
			checkable = true,
			isNotRadio = true,
		},
		{
			name = BANKGUI_TOOLTIPS,
			checkable = true,
			isNotRadio = true,
		},
		{
			name = BANKGUI_HOOVER,
			checkable = true,
			isNotRadio = true,
		},
		{
			name = BANKGUI_BANKSKIN,
			checkable = true,
			isNotRadio = true,
		},
		{
			name = BANKGUI_TRANSPARENT,
			checkable = true,
			isNotRadio = true,
		},
		{
			name = BANKGUI_BARCOLOR,
			checkable = false,
		},
		{
			name = BANKGUI_BACKCOLOR,
			checkable = false,
		},
		{
			name = BANKGUI_RESETCOLORS,
			checkable = false,
		},
	},
}


--[[
bank_crafts = {
	["Milling"] = true,
	["Prospecting"] = true,
}
--]]

BankListPlayers = {}

BankListGuildInfo = {}

BankListItems = {}
BankListGuildItems = {}
BankListCurrency = {}
BankListFriends = {}
BankListGlyphs  = {}
BankListFarms = {}
BankListOptions = {}



function BankGUI_OnHyperlinkClick(_, _, linktext, mousebutton)
	if mousebutton and linktext and not bank_ahopened then
		if IsAltKeyDown() and IsShiftKeyDown() then
			if not BankGUIFrame:IsVisible() then BankGUI:ToggleTab() end
			BankGUIFarmFrame:Show()
			BankGUIFarmItemBox:SetText("")
			BankGUIFarmItemBox:Insert(linktext)
			BankGUIFarmItemBox:SetCursorPosition(0)
			if BankGUIFarmAmountBox:GetNumber() == 0 then BankGUIFarmAmountBox:Insert("1") end
			BankGUIFarmAmountBox:SetFocus()
		elseif IsAltKeyDown() then
			linktext = GetItemInfo(linktext)
			if linktext then
				BankGUI:ShowTab()
				BankGUIFilterTextBox:SetText("")
				BankGUIFilterTextBox:Insert(linktext)
				BankGUIFilterTextBox:SetCursorPosition(0)
			end
		end
	end
end


function BankGUI_OnHyperlinkEnter(self, linkData, linktext, mousebutton)
	if string.find(linktext, "|Htrade:") ~= nil then
		bank_tradeskill_prof = linktext
		bank_tradeskill_titl = nil
		i, j = string.find(bank_tradeskill_prof, "Htrade:")
		if j ~= nil then
			i = string.find(bank_tradeskill_prof, "|h", j)
			i = i + 3
			j = string.find(bank_tradeskill_prof, "|h", i)
			bank_tradeskill_titl = string.sub(bank_tradeskill_prof, i, (j-2))
			--BankGUI.chat:AddMessage(bank_tradeskill_titl)
		end
		return
	end
	if not BankListOptions[BankGUI.realmname][1][BANKGUI_TOOLTIPS] then return end
	if string.find(linktext, "player:") ~= nil then
		local i, j, bank_hyperlinkplayer = string.find(linkData, "player:")
		if i ~= nil then i = string.find(linkData, ":", j+1) end
		if i ~= nil then
			bank_hyperlinkplayer = string.sub(linkData, j+1, i-1)
			if bank_hyperlinkplayer == BankGUI.playername then return end
			if BankListFL[bank_hyperlinkplayer] then
				GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
				if BankListFL[bank_hyperlinkplayer].level ~= nil then
					GameTooltip:AddLine( format("|cffff8000Level|r |cffffffff%i|r", BankListFL[bank_hyperlinkplayer].level) )
				end
				if BankListFL[bank_hyperlinkplayer].class ~= nil then
					GameTooltip:AddLine( format("|cffff8000Class|r |cffffffff%s|r", BankListFL[bank_hyperlinkplayer].class) )
				end
				if BankListFL[bank_hyperlinkplayer].note ~= nil then
					GameTooltip:AddLine( format("|cffff8000Note|r |cffffffff%s|r", BankListFL[bank_hyperlinkplayer].note) )
				end
				GameTooltip:Show()
				return
			end
			GameTooltip:Show()
		end
	elseif string.find(linktext, "|Hitem:") ~= nil then
		local itemname, itemlink = GetItemInfo(linktext)
		if BankGUI.BankListStock[itemname] then
			GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
			BankGUI:AddTooltip(GameTooltip, itemname)
			return
		end
	elseif string.find(linktext, "|Hcurrency:") ~= nil then
		if BankGUI.BankListStock[linktext] then
			GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
			BankGUI:AddTooltip(GameTooltip, linktext)
			return
		end
	end
end


function BankGUI_OnHyperlinkLeave()
	if not BankListOptions[BankGUI.realmname][1][BANKGUI_TOOLTIPS] then return end
	GameTooltip:Hide()
end


function BankGUI_OnShowFriendsFrame()
	if _G["FriendsFrame"].selectedTab == BankGUI.numtab then BankGUI:ShowTab() end
end


function BankGUI_TradeSkillAdd_OnYes()
	local tradeinfo= {}
	for i = 1, table.getn(BankListItems[BankGUI.realmname]) do
		if BankListItems[BankGUI.realmname][i].type == BANKGUI_TYPE_TRADELINK and BankListItems[BankGUI.realmname][i].name == bank_tradeskill_name and string.find(BankListItems[BankGUI.realmname][i].item, bank_tradeskill_titl) ~= nil then
			BankListItems[BankGUI.realmname][i].item = bank_tradeskill_prof
			BankListItems[BankGUI.realmname][i].amount = date("%d/%m/%y %H:%M")
			BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText())
			return
		end
	end
	tradeinfo["type"] = BANKGUI_TYPE_TRADELINK
	tradeinfo["name"] = bank_tradeskill_name
	tradeinfo["amount"] = date("%d/%m/%y %H:%M")
	tradeinfo["item"] = bank_tradeskill_prof
	tradeinfo["bank"] = false
	tradeinfo["faction"] = UnitFactionGroup("player"),
	table.insert(BankListItems[BankGUI.realmname], tradeinfo)
	--[[table.sort( BankListItems[BankGUI.realmname],
		function(a, b)
			local i = string.find(a.item,"|h")
			local j = string.find(b.item,"|h")
			if i == nil then i = 1 end
			if j == nil then j = 1 end
			if a.name == b.name then return string.sub(a.item,i) < string.sub(b.item,j)
			else return a.name < b.name end
		end
	)--]]
	BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText())
end


function BankGUI:ShowTab()
	if BankGUI.agrogained then return end
	if BankListOptions[BankGUI.realmname][1].detach then
		PlaySound("igCharacterInfoTab");
		BankGUIFrame:Show()
	else
		if not _G["FriendsFrame"]:IsVisible() then ToggleFriendsFrame() end
		PanelTemplates_SetTab(_G["FriendsFrame"], BankGUI.numtab)
		FriendsFrame_ShowSubFrame("BankGUIFrame")
	end
end


function BankGUI:ToggleTab()
	if BankGUI.agrogained then return end
	if BankListOptions[BankGUI.realmname][1].detach then
		if BankGUIFrame:IsVisible() then
			PlaySound("igMainMenuClose");
			BankGUIFrame:Hide()
		else
			PlaySound("igCharacterInfoTab");
			BankGUIFrame:Show()
		end
	else
		ToggleFriendsFrame()
		if _G["FriendsFrame"]:IsVisible() then
			--_G["FriendsListFrame"]:Hide()
			PanelTemplates_SetTab(_G["FriendsFrame"], BankGUI.numtab)
			FriendsFrame_ShowSubFrame("BankGUIFrame")
		end
	end
end


function BankGUI:IsValidType(tempinfo)
	if tempinfo.type == nil then return false end
	if tonumber(tempinfo.type) == nil then return true end
	return ( tonumber(tempinfo.type) >= -3 )
end


function BankGUI:OnClickBankGUIButton(self, button)
	local index = self:GetID()
	local bankinfo = BankGUI:GetItemByIndex(index)
	HideDropDownMenu(1)
	if IsControlKeyDown() and IsAltKeyDown() and IsDressableItem(bankinfo.item) then
		if DemoFrame then model:TryOn(bankinfo.item) end
	elseif IsControlKeyDown() and IsDressableItem(bankinfo.item) then
		DressUpItemLink(bankinfo.item)
	elseif IsAltKeyDown() then
		if not BankGUIFrame:IsVisible() then BankGUI:ToggleTab() end
		BankGUIFarmFrame:Show()
		BankGUIFarmItemBox:SetText("")
		BankGUIFarmItemBox:Insert(bankinfo.item)
		BankGUIFarmItemBox:SetCursorPosition(0)
		if BankGUIFarmAmountBox:GetNumber() == 0 then BankGUIFarmAmountBox:Insert("1") end
		BankGUIFarmAmountBox:SetFocus()
	elseif button == "LeftButton" then
		BankGUI:SetSelectedBankGUI(index)
		BankGUI:UpdateUI()
		if IsShiftKeyDown() then
			if BankGUI.chat.editBox:HasFocus() then
				BankGUI.chat.editBox:SetText(bankinfo.item)
			elseif bankinfo.type == BANKGUI_TYPE_TRADELINK and not BankListOptions[BankGUI.realmname][1].guild_checked then
				BankGUI.chat:AddMessage( format("%s %s |cffffff80(%s)|r", bankinfo.name, bankinfo.item, bankinfo.amount), 0.5,1,1 )
			else
				BankGUI.chat:AddMessage(bankinfo.item)
			end
		elseif BankGUI:IsValidType(bankinfo) then
			BankGUI:ShowDetails()
		else
			BankGUIDetailsFrame:Hide()
		end
	elseif button == "RightButton" then
		BankGUI.ClickedIndex = index
		BankGUILinkDropDown.initialize = BankGUILinkDropDown_Initialize
		BankGUILinkDropDown.displayMode = "MENU"
		ToggleDropDownMenu(1, nil, BankGUILinkDropDown, "cursor")
	end
end


function BankGUI:UpdateUI()
	local numItems = BankGUI:GetNumItems()
	local blIndex, blOffset, blColor, bankinfo, disp, i, itemStackCount, itemTexture
	local selectedBankGUI = BankGUI:GetSelectedBankGUI()

	FauxScrollFrame_Update(_G["BankGUIScrollFrame"], numItems, BANKGUIS_TO_DISPLAY, FRIENDS_FRAME_BANKGUI_HEIGHT, nil, nil, nil, nil, nil, nil, true)
	blOffset = FauxScrollFrame_GetOffset(_G["BankGUIScrollFrame"])

	if numItems == 0 then
		for i = 1, BANKGUIS_TO_DISPLAY, 1 do
			_G["BankGUIButton"..i]:Hide()
		end
		return
	end

	if numItems > 0 then
		if selectedBankGUI == 0 or selectedBankGUI > numItems then
			BankGUI:SetSelectedBankGUI(1)
			selectedBankGUI = 1
		end
	end

	for i = 1, BANKGUIS_TO_DISPLAY, 1 do
		blIndex = i + blOffset
		disp = ""
		blColor = "|cffffffff"
		bankinfo = BankGUI:GetItemByIndex(blIndex)
		if bankinfo then
			if bankinfo.type == BANKGUI_TYPE_TRADELINK then
				disp = format("%s%s|r %s %s(%s)|r", bankinfo.color, bankinfo.name, bankinfo.item, bankinfo.color, bankinfo.amount)
			elseif bankinfo.type == BANKGUI_TYPE_FARMS then
				if not bankinfo.date then bankinfo.date = "" end
				disp = format("%s %s(%i)|r |cff808080%s|r", bankinfo.item, blColor, bankinfo.amount, bankinfo.date)
			elseif bankinfo.type == BANKGUI_TYPE_GLYPHS then
				if bankinfo.glyp == 1 then blColor = "|cff00ffff"
				else blColor = "|cff00a0a0"
				end
				disp = format("%s%s spec %i, slot %i|r", bankinfo.item, blColor, bankinfo.spec, bankinfo.slot)
			elseif bankinfo.type == BANKGUI_TYPE_FRIENDS then
				disp = bankinfo.name
				if bankinfo.level ~= nil then
					disp = disp ..format(" |cffffffff(%i, %s)|r", bankinfo.level, bankinfo.class)
				end
				if bankinfo.note ~= nil then
					disp = disp ..format(" |cffffff80%s|r", bankinfo.note)
				end
			elseif bankinfo.type == BANKGUI_TYPE_CURRENCY then
				if bankinfo.amount == nil then bankinfo.amount = 0 end
				if bankinfo.item == nil then bankinfo.item = "" end
				disp = format("%s%s|r (%i) |cffffff80%s|r", blColor, bankinfo.item, bankinfo.amount, bankinfo.name)
			else
				_, _, _, _, _, _, _, itemStackCount = GetItemInfo(bankinfo.item)
				if itemStackCount == nil then itemStackCount = 1 end
				disp = bankinfo.item
				if itemStackCount ~= 1 or BankListOptions[BankGUI.realmname][1][BANKGUI_TOTALS] == true then disp = disp ..format(" (%i)", bankinfo.amount) end
			end
		end
		_G["BankGUIButton"..i.."Text"]:SetText(disp)
		_G["BankGUIButton"..i]:SetID(blIndex)

		-- Update the highlight
		if blIndex == selectedBankGUI then
			_G["BankGUIButton"..i.."Texture"]:Show();
		else
			_G["BankGUIButton"..i.."Texture"]:Hide();
		end

		if blIndex > numItems then
			_G["BankGUIButton"..i]:Hide()
		else
			_G["BankGUIButton"..i]:Show()
		end
	end
end


function BankGUI:SortItems()
	table.sort( BankListItems[BankGUI.realmname],
	function(a, b)
		return a.name < b.name
	end )
	table.sort( BankListItems[BankGUI.realmname],
	function(a, b)
		local nA = GetItemInfo(a.item)
		local nB = GetItemInfo(b.item)
		if nA == nil then nA = a.item end
		if nB == nil then nB = b.item end
		if a.name == b.name then return nA < nB
		else return a.name < b.name end
	end )
end


function BankGUI:OnLoad(self)
	self:RegisterEvent("VARIABLES_LOADED")
	self:RegisterEvent("PLAYER_LOGIN")
	--self:RegisterEvent("PLAYER_LOGOUT")
	self:RegisterEvent("PLAYER_MONEY")
	self:RegisterEvent("PLAYER_GUILD_UPDATE")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
	self:RegisterEvent("BANKFRAME_OPENED")
	self:RegisterEvent("BANKFRAME_CLOSED")
	self:RegisterEvent("TRADE_SKILL_SHOW")
	self:RegisterEvent("GUILDBANKFRAME_OPENED")
	self:RegisterEvent("CURRENCY_DISPLAY_UPDATE")
	self:RegisterEvent("BAG_UPDATE")
	self:RegisterEvent("UPDATE_CHAT_COLOR")
	self:RegisterEvent("CHAT_MSG_WHISPER")
	--self:RegisterEvent("CHAT_MSG_BN_WHISPER")
	self:RegisterEvent("CHAT_MSG_SYSTEM")
	self:RegisterEvent("AUCTION_HOUSE_CLOSED")
	self:RegisterEvent("AUCTION_HOUSE_SHOW")
	--self:RegisterAllEvents()
	BankGUI.chat:AddMessage("|cffff8000" ..BINDING_HEADER_BANKGUI .."|r loaded. Go to |cffffff80Social (O)|r and select the |cffffff80Bank|r tab on the bottom right, or type |cffffff80/bank|r.", 0.5,1,1)
	SLASH_BANK1 = "/bank"
	SlashCmdList["BANK"] = function(msg)
		BankGUI:Bank_SlashCommandHandler(msg)
	end
end


local buttontexture

function BankGUI:SetFriendsFrameSkin()

	BankGUIScrollFrameScrollBarScrollUpButton:SetNormalTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Up")
	BankGUIScrollFrameScrollBarScrollUpButton:SetPushedTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Down")
	BankGUIScrollFrameScrollBarScrollUpButton:SetDisabledTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Disabled")
	BankGUIScrollFrameScrollBarScrollUpButton:SetHighlightTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Highlight", "ADD")
	BankGUIScrollFrameScrollBarScrollDownButton:SetNormalTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Up")
	BankGUIScrollFrameScrollBarScrollDownButton:SetPushedTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Down")
	BankGUIScrollFrameScrollBarScrollDownButton:SetDisabledTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Disabled")
	BankGUIScrollFrameScrollBarScrollDownButton:SetHighlightTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Highlight", "ADD")
	BankGUIScrollFrameScrollBarTop:Show()
	BankGUIScrollFrameScrollBarBot:Show()
	BankGUIScrollFrameBorder:Hide()

	BankGUIDetailsFrame:SetBackdrop( { bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", tile = true, tileSize = 32, edgeSize = 32, insets = { left = 11, right = 11, top = 11, bottom = 10 } } )
	BankGUIDetailsFrameTopLine:Hide()
	BankGUIDetailsFrameBotLine:Hide()
	BankGUIDetailsCorner:Show()
	BankGUIDetailsCloseButtonText:SetText("")
	BankGUIDetailsCloseButton:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up")
	buttontexture = BankGUIDetailsCloseButton:GetNormalTexture()
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997)
	buttontexture:SetBlendMode("BLEND")
	BankGUIDetailsCloseButton:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down")
	buttontexture = BankGUIDetailsCloseButton:GetPushedTexture()
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997)
	buttontexture:SetBlendMode("BLEND")

	BankGUICloseButtonText:SetText("")
	BankGUICloseButton:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up")
	buttontexture = BankGUICloseButton:GetNormalTexture()
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997)
	buttontexture:SetBlendMode("BLEND")
	BankGUICloseButton:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down")
	buttontexture = BankGUICloseButton:GetPushedTexture()
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997)
	buttontexture:SetBlendMode("BLEND")
	BankGUIDeleteButton.Left:Show()
	BankGUIDeleteButton.Middle:Show()
	BankGUIDeleteButton.Right:Show()
	BankGUIDeleteButton:SetNormalTexture("")
	BankGUIDeleteButton:SetHighlightTexture("Interface\\Buttons\\UI-Panel-Button-Highlight", "ADD")
	buttontexture = BankGUIDeleteButton:GetHighlightTexture()
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997)
	buttontexture:SetBlendMode("ADD")
	BankGUIDeleteButton:SetPushedTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	buttontexture = BankGUIDeleteButton:GetPushedTexture()
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997)
	buttontexture:SetBlendMode("BLEND")
	BankGUIDeleteButton:SetDisabledTexture("")
	BankGUIFarmAddButton:SetText("")
	BankGUIFarmAddButton:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up")
	buttontexture = BankGUIFarmAddButton:GetNormalTexture()
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997)
	buttontexture:SetBlendMode("BLEND")
	BankGUIFarmAddButton:SetPushedTexture("Interface\\Buttons\\UI-PlusButton-Down")
	buttontexture = BankGUIFarmAddButton:GetPushedTexture()
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997)
	buttontexture:SetBlendMode("BLEND")

	BankGUIPlayerDropDownLeft:Show()
	BankGUIPlayerDropDownMiddle:Show()
	BankGUIPlayerDropDownRight:Show()
	BankGUITypeDropDownLeft:Show()
	BankGUITypeDropDownMiddle:Show()
	BankGUITypeDropDownRight:Show()

	BankGUIFrameTopLine:Hide()
	BankGUIFrameCaption:Hide()
	BankGUIFrameMidLine:Hide()
	BankGUIFrameInfo:Hide()
	BankGUIFrameInfoLine:Hide()
	BankGUIFrameListBack:Hide()
	BankGUIFrameBackLine:Hide()
	BankGUIFrameCharBack:Hide()
	BankGUIFrameTypeBack:Hide()
	BankGUIFrameFilter:Hide()
	BankGUIFrameBotLine:Hide()
	BankGUIPlayerPortrait:Show()
	BankGUIFrameTopLeft:Show()
	BankGUIFrameTopRight:Show()
	BankGUIFrameBottomLeft:Show()
	BankGUIFrameBottomRight:Show()
	BankGUIDetailsFrame:SetAlpha(1.0)
	BankGUIFarmFrame:SetAlpha(1.0)
	BankGUIFrame:SetAlpha(1.0)

	BankGUIFarmFrame:SetBackdrop( { bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", tile = true, tileSize = 32, edgeSize = 32, insets = { left = 11, right = 11, top = 11, bottom = 10 } } )
	BankGUIFarmFrameTopLine:Hide()
	BankGUIFarmFrameCharBack:Hide()
	BankGUIFarmFrameBotLine:Hide()
	BankGUIFarmCorner:Show()
	BankGUIFarmPlayerDropDownLeft:Show()
	BankGUIFarmPlayerDropDownMiddle:Show()
	BankGUIFarmPlayerDropDownRight:Show()
	BankGUIFarmCloseButtonText:SetText("")
	BankGUIFarmCloseButton:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up")
	buttontexture = BankGUIFarmCloseButton:GetNormalTexture()
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997)
	buttontexture:SetBlendMode("BLEND")
	BankGUIFarmCloseButton:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down")
	buttontexture = BankGUIFarmCloseButton:GetPushedTexture()
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997)
	buttontexture:SetBlendMode("BLEND")
	BankGUIFarmAddItem.Left:Show()
	BankGUIFarmAddItem.Middle:Show()
	BankGUIFarmAddItem.Right:Show()
	BankGUIFarmAddItem:SetNormalTexture("")
	BankGUIFarmAddItem:SetHighlightTexture("Interface\\Buttons\\UI-Panel-Button-Highlight", "ADD")
	buttontexture = BankGUIFarmAddItem:GetHighlightTexture()
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997)
	buttontexture:SetBlendMode("ADD")
	BankGUIFarmAddItem:SetPushedTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	buttontexture = BankGUIFarmAddItem:GetPushedTexture()
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997)
	buttontexture:SetBlendMode("BLEND")
	BankGUIFarmAddItem:SetDisabledTexture("Interface\\Buttons\\UI-Panel-Button-Disabled")
	buttontexture = BankGUIFarmAddItem:GetDisabledTexture()
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997)
	buttontexture:SetBlendMode("ADD")
	BankGUIFarmCancelItem.Left:Show()
	BankGUIFarmCancelItem.Middle:Show()
	BankGUIFarmCancelItem.Right:Show()
	BankGUIFarmCancelItem:SetNormalTexture("")
	BankGUIFarmCancelItem:SetHighlightTexture("Interface\\Buttons\\UI-Panel-Button-Highlight", "ADD")
	buttontexture = BankGUIFarmCancelItem:GetHighlightTexture()
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997)
	buttontexture:SetBlendMode("ADD")
	BankGUIFarmCancelItem:SetPushedTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	buttontexture = BankGUIFarmCancelItem:GetPushedTexture()
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997)
	buttontexture:SetBlendMode("BLEND")
	BankGUIFarmCancelItem:SetDisabledTexture("Interface\\Buttons\\UI-Panel-Button-Disabled")
	buttontexture = BankGUIFarmCancelItem:GetDisabledTexture()
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997)
	buttontexture:SetBlendMode("ADD")
end


function BankGUI:SetBankGUIFrameSkin()

	BankGUIScrollFrameScrollBarScrollUpButton:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollUp-Up")
	BankGUIScrollFrameScrollBarScrollUpButton:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollUp-Down")
	BankGUIScrollFrameScrollBarScrollUpButton:SetDisabledTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollUp-Disabled")
	BankGUIScrollFrameScrollBarScrollUpButton:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight", "ADD")
	BankGUIScrollFrameScrollBarScrollDownButton:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Up")
	BankGUIScrollFrameScrollBarScrollDownButton:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Down")
	BankGUIScrollFrameScrollBarScrollDownButton:SetDisabledTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Disabled")
	BankGUIScrollFrameScrollBarScrollDownButton:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight", "ADD")
	BankGUIScrollFrameScrollBarTop:Hide()
	BankGUIScrollFrameScrollBarBot:Hide()
	BankGUIScrollFrameBorder:Show()

	BankGUIDetailsFrame:SetBackdrop( { bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", edgeFile = nil, tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 7, bottom = 7 } } )
	BankGUIDetailsFrameTopLine:Show()
	BankGUIDetailsFrameBotLine:Show()
	BankGUIDetailsCorner:Hide()
	BankGUIDetailsCloseButtonText:SetText("X")
	buttontexture = BankGUIDetailsCloseButton:GetNormalTexture()
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(0.5, 0.0, 0.0, 1.0)
	buttontexture = BankGUIDetailsCloseButton:GetPushedTexture()
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(0.2, 0.0, 0.0, 1.0)

	BankGUI:SetBankGUIBarColor()

	BankGUICloseButtonText:SetText("X")
	buttontexture = BankGUICloseButton:GetNormalTexture()
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(0.5, 0.0, 0.0, 1.0)
	buttontexture = BankGUICloseButton:GetPushedTexture()
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(0.2, 0.0, 0.0, 1.0)
	BankGUIDeleteButton.Left:Hide()
	BankGUIDeleteButton.Middle:Hide()
	BankGUIDeleteButton.Right:Hide()
	BankGUIDeleteButton:SetNormalTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture = BankGUIDeleteButton:GetNormalTexture()
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(0.5, 0.0, 0.0, 1.0)
	buttontexture = BankGUIDeleteButton:GetHighlightTexture()
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(1.0, 0.0, 0.0, 1.0)
	buttontexture = BankGUIDeleteButton:GetPushedTexture()
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(0.2, 0.0, 0.0, 1.0)
	BankGUIDeleteButton:SetDisabledTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture = BankGUIDeleteButton:GetDisabledTexture()
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(0.33, 0.33, 0.33, 1.0)
	BankGUIFarmAddButtonText:SetText("+")
	buttontexture = BankGUIFarmAddButton:GetNormalTexture()
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(0.5, 0.0, 0.0, 1.0)
	buttontexture = BankGUIFarmAddButton:GetPushedTexture()
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(0.2, 0.0, 0.0, 1.0)

	BankGUIPlayerDropDownLeft:Hide()
	BankGUIPlayerDropDownMiddle:Hide()
	BankGUIPlayerDropDownRight:Hide()
	BankGUITypeDropDownLeft:Hide()
	BankGUITypeDropDownMiddle:Hide()
	BankGUITypeDropDownRight:Hide()

	BankGUIPlayerPortrait:Show()
	BankGUIFrameTopLeft:Hide()
	BankGUIFrameTopRight:Hide()
	BankGUIFrameBottomLeft:Hide()
	BankGUIFrameBottomRight:Hide()
	BankGUIFrameTopLine:Show()
	BankGUIFrameCaption:Show()
	BankGUIFrameMidLine:Show()
	BankGUIFrameInfo:Show()
	BankGUIFrameInfoLine:Show()
	BankGUIFrameListBack:Show()
	BankGUIFrameBackLine:Show()
	BankGUIFrameCharBack:Show()
	BankGUIFrameTypeBack:Show()
	BankGUIFrameFilter:Show()
	BankGUIFrameBotLine:Show()

	BankGUIFarmFrame:SetBackdrop( { bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", edgeFile = nil, tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 7, bottom = 7 } } ) --"Interface\\Tooltips\\UI-Tooltip-Border"
	BankGUIFarmFrameTopLine:Show()
	BankGUIFarmFrameCharBack:Show()
	BankGUIFarmFrameBotLine:Show()
	BankGUIFarmCorner:Hide()
	BankGUIFarmPlayerDropDownLeft:Hide()
	BankGUIFarmPlayerDropDownMiddle:Hide()
	BankGUIFarmPlayerDropDownRight:Hide()
	BankGUIFarmCloseButtonText:SetText("X")
	buttontexture = BankGUIFarmCloseButton:GetNormalTexture()
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(0.5, 0.0, 0.0, 1.0)
	buttontexture = BankGUIFarmCloseButton:GetPushedTexture()
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(0.2, 0.0, 0.0, 1.0)
	BankGUIFarmAddItem.Left:Hide()
	BankGUIFarmAddItem.Middle:Hide()
	BankGUIFarmAddItem.Right:Hide()
	BankGUIFarmAddItem:SetNormalTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture = BankGUIFarmAddItem:GetNormalTexture()
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(0.5, 0.0, 0.0, 1.0)
	buttontexture = BankGUIFarmAddItem:GetHighlightTexture()
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(1.0, 0.0, 0.0, 1.0)
	buttontexture = BankGUIFarmAddItem:GetPushedTexture()
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(0.2, 0.0, 0.0, 1.0)
	buttontexture = BankGUIFarmAddItem:GetDisabledTexture()
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(0.33, 0.33, 0.33, 1.0)
	BankGUIFarmCancelItem.Left:Hide()
	BankGUIFarmCancelItem.Middle:Hide()
	BankGUIFarmCancelItem.Right:Hide()
	BankGUIFarmCancelItem:SetNormalTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture = BankGUIFarmCancelItem:GetNormalTexture()
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(0.5, 0.0, 0.0, 1.0)
	buttontexture = BankGUIFarmCancelItem:GetHighlightTexture()
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(1.0, 0.0, 0.0, 1.0)
	buttontexture = BankGUIFarmCancelItem:GetPushedTexture()
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(0.2, 0.0, 0.0, 1.0)
	buttontexture = BankGUIFarmCancelItem:GetDisabledTexture()
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
	buttontexture:SetBlendMode("ADD")
	buttontexture:SetVertexColor(0.33, 0.33, 0.33, 1.0)

	BankGUI:SetBankGUIBackgroundColor()
end


function BankGUI:SetBankFrameBackGround()
	BankGUI:SetFriendsFrameSkin()
	if BankListOptions[BankGUI.realmname][1].detach then
		if BankListOptions[BankGUI.realmname][1][ BANKGUI_BANKSKIN ] then
			BankGUI:SetBankGUIFrameSkin()
		else
			BankGUI:SetFriendsFrameSkin()
		end
		if BankListOptions[BankGUI.realmname][1][ BANKGUI_TRANSPARENT ] then
			if BankListOptions[BankGUI.realmname][1][ BANKGUI_BANKSKIN ] then BankGUIPlayerPortrait:Hide()
			else BankGUIPlayerPortrait:Show()
			end
			BankGUIFrame:SetAlpha(0.5)
			BankGUIDetailsFrame:SetAlpha(0.5)
			BankGUIFarmFrame:SetAlpha(0.5)
		else
			BankGUIFrame:SetAlpha(1.0)
			BankGUIDetailsFrame:SetAlpha(1.0)
			BankGUIFarmFrame:SetAlpha(1.0)
		end
	else
		BankGUI:SetFriendsFrameSkin()
		BankGUIFrame:SetAlpha(1.0)
		BankGUIDetailsFrame:SetAlpha(1.0)
		BankGUIFarmFrame:SetAlpha(1.0)
	end
end


function BankGUI:SetBankGUIBarColor()
	if BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ] == nil then return end
	local i
	for i = 1, BANKGUIS_TO_DISPLAY do
		if _G["BankGUIButton" ..i] ~= nil then
			if BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ].a ~= nil then
				_G["BankGUIButton" ..i.."Texture"]:SetVertexColor( BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ].r, BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ].g, BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ].b, BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ].a )
				_G["BankGUIButton" ..i]:GetHighlightTexture():SetVertexColor( BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ].r, BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ].g, BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ].b, BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ].a )
			else
				_G["BankGUIButton" ..i.."Texture"]:SetVertexColor( BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ].r, BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ].g, BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ].b, 1.0 )
				_G["BankGUIButton" ..i]:GetHighlightTexture():SetVertexColor( BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ].r, BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ].g, BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ].b, 1.0 )
			end
		end
	end
end


function BankGUI:SetBankGUIBackgroundColor()
	if BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ] == nil then return end
	BankGUIFrameListBack:SetTexture( BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].r, BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].g, BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].b, BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].a )
	BankGUIDetailsFrame:SetBackdropColor( BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].r, BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].g, BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].b, BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].a )
	BankGUIFarmFrame:SetBackdropColor( BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].r, BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].g, BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].b, BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].a )
	BankGUIFarmFrame:SetBackdropColor( BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].r, BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].g, BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].b, BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].a )
end


function BankGUI:ResetBankGUIBarColor()
	BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ] = {}
	BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ].r = 1.0
	BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ].g = 0.5
	BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ].b = 0.0
	BankListOptions[BankGUI.realmname][1][ BANKGUI_BARCOLOR ].a = 1.0
end


function BankGUI:ResetBankGUIBackgroundColor()
	BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ] = {}
	BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].r = 0.05
	BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].g = 0.025
	BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].b = 0.0
	BankListOptions[BankGUI.realmname][1][ BANKGUI_BACKCOLOR ].a = 0.5
end


function BankGUI:CheckChildFrames()
	BankGUIFarmFrame:ClearAllPoints()
	BankGUIDetailsFrame:ClearAllPoints()
	if not BankGUIFrame:GetRight() or (BankGUIFrame:GetRight() + BankGUIFarmFrame:GetWidth() + 30 < GetScreenWidth()) then
		BankGUIFarmFrame:SetPoint("TOPLEFT", "BankGUIFrame", "TOPRIGHT", -10, -210)
	else
		BankGUIFarmFrame:SetPoint("TOPRIGHT", "BankGUIFrame", "TOPLEFT", 10, -210)
	end
	if not BankGUIFrame:GetRight() or (BankGUIFrame:GetRight() + BankGUIDetailsFrame:GetWidth() + 30 < GetScreenWidth()) then
		BankGUIDetailsFrame:SetPoint("TOPLEFT", "BankGUIFrame", "TOPRIGHT", -10, -75)
	else
		BankGUIDetailsFrame:SetPoint("TOPRIGHT", "BankGUIFrame", "TOPLEFT", 10, -75)
	end
end


function BankGUI:AddTooltip(tooltip, itemname)
	if not BankListOptions[BankGUI.realmname][1][BANKGUI_TOOLTIPS] then return end
	if BankGUI.BankListStock and BankGUI.BankListStock[itemname] then
		if BankGUI.BankListStock[itemname].stock ~= nil then
			if BankGUI.BankListStock[itemname].self ~= nil then
				tooltip:AddLine( format("|cffff8000In Stock|r |cffffffff%i (%i)|r", BankGUI.BankListStock[itemname].stock, BankGUI.BankListStock[itemname].self) )
			else
				tooltip:AddLine( format("|cffff8000In Stock|r |cffffffff%i|r", BankGUI.BankListStock[itemname].stock) )
			end
		end
		if BankGUI.BankListStock[itemname].bagged ~= nil then
			tooltip:AddLine( format("|cffff8000In Bags|r |cffffffff%i|r", BankGUI.BankListStock[itemname].bagged) )
		end
		if BankGUI.BankListStock[itemname].farm ~= nil then
			if ( BankGUI.BankListStock[itemname].self and BankGUI.BankListStock[itemname].self >= BankGUI.BankListStock[ itemname ].farm.amount ) or ( BankGUI.BankListStock[itemname].bagged and BankGUI.BankListStock[itemname].bagged >= BankGUI.BankListStock[ itemname ].farm.amount ) then
				tooltip:AddLine( format("|cffff8000Farm|r |cff22ff22%i, |cffe02222you'r done!|r (%s)|r", BankGUI.BankListStock[ itemname ].farm.amount, BankGUI.BankListStock[itemname].farm.name) )
			else
				tooltip:AddLine( format("|cffff8000Farm|r |cffffffff%i|r |cff808080(%s, %s)|r", BankGUI.BankListStock[ itemname ].farm.amount, BankGUI.BankListStock[itemname].farm.date, BankGUI.BankListStock[itemname].farm.name) )
			end
		end
	end
	tooltip:Show()
end


function BankGUI:Convert()
	local i, x, y, bankinfo = 1, 0, 0, {}
	if not BankListCurrency then BankListCurrency = {} end
	if not BankListCurrency[BankGUI.realmname] then BankListCurrency[BankGUI.realmname] = {} end
	if not BankListFriends then BankListFriends = {} end
	if not BankListFriends[BankGUI.realmname] then BankListFriends[BankGUI.realmname] = {} end
	if not BankListGlyphs then BankListGlyphs = {} end
	if not BankListGlyphs[BankGUI.realmname] then BankListGlyphs[BankGUI.realmname] = {} end
	if not BankListFarms then BankListFarms = {} end
	if not BankListFarms[BankGUI.realmname] then BankListFarms[BankGUI.realmname] = {} end
	while true do
	  for i = 1, table.getn(BankListItems[BankGUI.realmname]) do
		if BankListItems[BankGUI.realmname][i].type == BANKGUI_TYPE_CURRENCY then
			bankinfo = {}
			bankinfo.name = BankListItems[BankGUI.realmname][i].name
			bankinfo.item = BankListItems[BankGUI.realmname][i].item
			bankinfo.amount = BankListItems[BankGUI.realmname][i].amount
			table.insert(BankListCurrency[BankGUI.realmname], bankinfo)
			table.remove(BankListItems[BankGUI.realmname], i)
			break
		end
		if BankListItems[BankGUI.realmname][i].type == BANKGUI_TYPE_FRIENDS then
			bankinfo = {}
			x, y = string.find(BankListItems[BankGUI.realmname][i].item, " ")
			if x then
				y = ( x - 1 )
				x = 1
				bankinfo.name = string.sub(BankListItems[BankGUI.realmname][i].item, x, y)
			else
				bankinfo.name = BankListItems[BankGUI.realmname][i].item
			end
			bankinfo.level = 0
			bankinfo.class = UNKNOWN
			x, y = string.find(BankListItems[BankGUI.realmname][i].item, "|cffffff80")
			if x then
				x = y + 1
				y = ( string.len(BankListItems[BankGUI.realmname][i].item) - 2 )
				bankinfo.note = string.sub(BankListItems[BankGUI.realmname][i].item, x, y)
			end
			table.insert(BankListFriends[BankGUI.realmname], bankinfo)
			table.remove(BankListItems[BankGUI.realmname], i)
			break
		end
		if BankListItems[BankGUI.realmname][i].type == BANKGUI_TYPE_GLYPHS then
			bankinfo = {}
			bankinfo.name = BankListItems[BankGUI.realmname][i].name
			bankinfo.spec = GetActiveSpecGroup()
			bankinfo.item = BankListItems[BankGUI.realmname][i].item
			bankinfo.slot = tonumber( BankListItems[BankGUI.realmname][i].bank )
			table.insert(BankListGlyphs[BankGUI.realmname], bankinfo)
			table.remove(BankListItems[BankGUI.realmname], i)
			break
		end
		if BankListItems[BankGUI.realmname][i].type == BANKGUI_TYPE_FARMS then
			bankinfo = {}
			bankinfo.name = BankListItems[BankGUI.realmname][i].name
			bankinfo.item = BankListItems[BankGUI.realmname][i].item
			bankinfo.amount = BankListItems[BankGUI.realmname][i].amount
			bankinfo.date = BankListItems[BankGUI.realmname][i].bank
			table.insert(BankListFarms[BankGUI.realmname], bankinfo)
			table.remove(BankListItems[BankGUI.realmname], i)
			break
		end
	  end
	  i = i + 1
	  if table.getn(BankListItems[BankGUI.realmname]) == 0 then return end
	  if i >= table.getn(BankListItems[BankGUI.realmname]) then return end
	end
end


function BankGUI:UpdateCurrency()
	BankGUI.realmname = GetRealmName()
	BankGUI.playername = UnitName("player")
	BankGUI.playerfaction = UnitFactionGroup("player")
	local i, j
	for j = 1, table.getn(BankListCurrency[BankGUI.realmname]) do
		if BankListCurrency[BankGUI.realmname][j] and BankListCurrency[BankGUI.realmname][j].name == BankGUI.playername then
			table.remove(BankListCurrency[BankGUI.realmname], j)
		end
		if j > table.getn(BankListCurrency[BankGUI.realmname]) then break end
	end
	if not BankListOptions[BankGUI.realmname][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPCURR] then return end
	if not BankGUI.playername or string.len(BankGUI.playername) == 0 then return end
	local bank_cl_name, bank_cl_isheader, bank_cl_amount, bank_cl_link, bank_cl_already
	local bankinfo_curr = {}
	for i = 1, GetCurrencyListSize() do
		bank_cl_name, bank_cl_isheader, _, _, _, bank_cl_amount = GetCurrencyListInfo(i)
		if bank_cl_name and not bank_cl_isheader then
			bank_cl_link = GetCurrencyListLink(i)
			bank_cl_already = false
			for j = 1, table.getn(BankListCurrency[BankGUI.realmname]) do
				if BankListCurrency[BankGUI.realmname][j].item == nil then
					table.remove(BankListCurrency[BankGUI.realmname], j)
				end
				if j > table.getn(BankListCurrency[BankGUI.realmname]) then break end
				if BankListCurrency[BankGUI.realmname][j].name == BankGUI.playername and BankListCurrency[BankGUI.realmname][j].item == bank_cl_link then
					bank_cl_already = true
					BankListCurrency[BankGUI.realmname][j].amount = bank_cl_amount
					break
				end
			end
			if not bank_cl_already then
				bankinfo_curr = {}
				bankinfo_curr.name = BankGUI.playername
				bankinfo_curr.item = bank_cl_link
				bankinfo_curr.amount = bank_cl_amount
				table.insert(BankListCurrency[BankGUI.realmname], bankinfo_curr)
			end
		end
	end
	for j = 1, table.getn(BankListCurrency[BankGUI.realmname]) do
		if BankListCurrency[BankGUI.realmname][j].item == nil then
			table.remove(BankListCurrency[BankGUI.realmname], j)
		end
		if j > table.getn(BankListCurrency[BankGUI.realmname]) then break end
	end
	table.sort(BankListCurrency[BankGUI.realmname],
		function(a, b)
			if not a.name then return true end
			if not b.name then return false end
			return a.name < b.name
		end
	)
	table.sort(BankListCurrency[BankGUI.realmname],
		function(a, b)
			if not a.name then return true end
			if not b.name then return false end
			if a.name == b.name then return a.item < b.item else return a.name < b.name end
		end
	)
end


function BankGUI:UpdateFriends()
	BankGUI.realmname = GetRealmName()
	if not BankListOptions[BankGUI.realmname][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPFRIEND] then return end
	ShowFriends()
	local bank_friend_name, bank_friend_level, bank_friend_class, bank_friend_connected, bank_friend_note
	local i, j, bank_friend_already, bank_friend_connected = 0, 0, false, false
	local bankinfo_friend = nil
	for i = 1, GetNumFriends() do
		bank_friend_name, bank_friend_level, bank_friend_class, _, bank_friend_connected, _, bank_friend_note = GetFriendInfo(i)
		if bank_friend_name then
			bank_friend_already = false
			for j = 1, table.getn(BankListFriends[BankGUI.realmname]) do
				if BankListFriends[BankGUI.realmname][j].name == nil then
					table.remove(BankListFriends[BankGUI.realmname], j)
				end
				if j > table.getn(BankListFriends[BankGUI.realmname]) then break end
				if BankListFriends[BankGUI.realmname][j].name == bank_friend_name then
					bank_friend_already = true
					if bank_friend_connected and bank_friend_level > 0 then
						BankListFriends[BankGUI.realmname][j].level = bank_friend_level
						BankListFriends[BankGUI.realmname][j].class = bank_friend_class
					else
						BankListFriends[BankGUI.realmname][j].level = 0
						BankListFriends[BankGUI.realmname][j].class = UNKNOWN
					end
					if bank_friend_note ~= nil and bank_friend_note ~= "" then
						BankListFriends[BankGUI.realmname][j].note = bank_friend_note
					end
					BankListFriends[BankGUI.realmname][j].faction = BankGUI.playerfaction
				end
			end
			if not bank_friend_already then
				bankinfo_friend = {}
				bankinfo_friend.name = bank_friend_name
				bankinfo_friend.level = bank_friend_level
				bankinfo_friend.class = bank_friend_class
				bankinfo_friend.note = bank_friend_note
				bankinfo_friend.faction = BankGUI.playerfaction
				table.insert(BankListFriends[BankGUI.realmname], bankinfo_friend)
			end
		end
	end
	if BankListFriends ~= nil and BankListFriends[BankGUI.realmname] ~= nil then
		table.sort(BankListFriends[BankGUI.realmname], function(a, b) return (a.name < b.name) end )
		for i = 1, table.getn(BankListFriends[BankGUI.realmname]) do
			BankListFL[ BankListFriends[BankGUI.realmname][i].name ] = {}
			BankListFL[ BankListFriends[BankGUI.realmname][i].name ].level = BankListFriends[BankGUI.realmname][i].level
			BankListFL[ BankListFriends[BankGUI.realmname][i].name ].class = BankListFriends[BankGUI.realmname][i].class
			BankListFL[ BankListFriends[BankGUI.realmname][i].name ].note = BankListFriends[BankGUI.realmname][i].note
			if BankListFriends[BankGUI.realmname][i].faction ~= nil then
				BankListFL[ BankListFriends[BankGUI.realmname][i].name ].faction = BankListFriends[BankGUI.realmname][i].faction
			else
				BankListFL[ BankListFriends[BankGUI.realmname][i].name ].faction = UNKNOWN
			end
		end
	end
end


function BankGUI:UpdateGlyphs()
	BankGUI.realmname = GetRealmName()
	if not BankListOptions[BankGUI.realmname][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPGLYPS] then return end
	local glyph_enabled, glyph_type, glyph_SpellID, glyph_itemlink, glyph_already
	local bankinfo_glyph = {}
	for i = 1, GetNumGlyphSockets() do
		glyph_SpellID, glyph_itemlink, glyph_already = nil, nil, false
		glyph_enabled, glyph_type, glyph_SpellID, _ = GetGlyphSocketInfo(i)
		if glyph_enabled and glyph_SpellID ~= nil then
			glyph_itemlink = GetGlyphLink(i)
			if glyph_itemlink then
				for j = 1, table.getn(BankListGlyphs[BankGUI.realmname]) do
					if BankListGlyphs[BankGUI.realmname][j].name == nil or BankListGlyphs[BankGUI.realmname][j].item == nil then
						table.remove(BankListGlyphs[BankGUI.realmname], j)
					end
					if j > table.getn(BankListGlyphs[BankGUI.realmname]) then break end
					if BankListGlyphs[BankGUI.realmname][j].spec == nil then BankListGlyphs[BankGUI.realmname][j].spec = GetActiveSpecGroup() end
					if BankListGlyphs[BankGUI.realmname][j].name == BankGUI.playername and BankListGlyphs[BankGUI.realmname][j].spec == GetActiveSpecGroup() and BankListGlyphs[BankGUI.realmname][j]["slot"] == i then
						glyph_already = true
						BankListGlyphs[BankGUI.realmname][j].item = glyph_itemlink
						BankListGlyphs[BankGUI.realmname][j].glyp = glyph_type
						break
					end
				end
				if not glyph_already then
					bankinfo_glyph = {}
					bankinfo_glyph.name = BankGUI.playername
					bankinfo_glyph.spec = GetActiveSpecGroup()
					bankinfo_glyph.item = glyph_itemlink
					bankinfo_glyph.glyp = glyph_type
					bankinfo_glyph.slot = i
					table.insert(BankListGlyphs[BankGUI.realmname], bankinfo_glyph)
				end
			else
				for j = 1, table.getn(BankListGlyphs[BankGUI.realmname]) do
					if BankListGlyphs[BankGUI.realmname][j].name == BankGUI.playername and BankListGlyphs[BankGUI.realmname][j].spec == GetActiveSpecGroup() and BankListGlyphs[BankGUI.realmname][j]["slot"] == i then
						table.remove(BankListItems[BankGUI.realmname], BankGUI:GetBankItemIndexByName(BankListGlyphs[BankGUI.realmname][j].item))
						break
					end
				end
			end
		end
	end
	table.sort(BankListGlyphs[BankGUI.realmname],
		function(a, b)
			return a.name < b.name
		end
	)
	table.sort(BankListGlyphs[BankGUI.realmname],
		function(a, b)
			if a.name == b.name then
				return a["spec"] < b["spec"]
			else
				return a.name < b.name
			end
		end
	)
	table.sort(BankListGlyphs[BankGUI.realmname],
		function(a, b)
			if a.name == b.name then
				if a["spec"] == b["spec"] then
					return a["slot"] < b["slot"]
				else
					return a["spec"] < b["spec"]
				end
			else
				return a.name < b.name
			end
		end
	)
end


function BankGUI:UpdateStock()
	BankGUI.realmname = GetRealmName()
	local i, j, itemname, itemlink, itemrarity, itemcount, itemstack
	BankGUI.BankListStock = {}
	for i = 1, table.getn(BankListItems[BankGUI.realmname]) do
		if ( BankListOptions[BankGUI.realmname][1][BANKGUI_FACTION] or (BankGUI.BankFactionColors[ BankListItems[BankGUI.realmname][i].name ] and BankGUI.BankFactionColors[ BankListItems[BankGUI.realmname][i].name ].faction and BankGUI.BankFactionColors[ BankListItems[BankGUI.realmname][i].name ].faction == BankGUI.playerfaction) )
		and (BankGUI:IsValidType(BankListItems[BankGUI.realmname][i])) then
			itemname, _, _, _, _, _, _, itemstack = GetItemInfo(BankListItems[BankGUI.realmname][i].item)
			if itemname and itemstack > 1 then
				if not BankGUI.BankListStock[ itemname ] then BankGUI.BankListStock[ itemname ] = {} end
				if not BankGUI.BankListStock[ itemname ].stock then BankGUI.BankListStock[ itemname ].stock = 0 end
				if not BankGUI.BankListStock[ itemname ].self then BankGUI.BankListStock[ itemname ].self = 0 end
				BankGUI.BankListStock[ itemname ].stock = BankGUI.BankListStock[ itemname ].stock + BankListItems[BankGUI.realmname][i].amount
				if BankListItems[BankGUI.realmname][i].name == BankGUI.playername then BankGUI.BankListStock[ itemname ].self = BankGUI.BankListStock[ itemname ].self + BankListItems[BankGUI.realmname][i].amount end
			end
		end
	end
	for j = -2, -2 do
		for i = 1, GetContainerNumSlots(j) do
			itemlink = GetContainerItemLink(j, i)
			if itemlink then
				_, itemcount = GetContainerItemInfo(j, i)
				itemname, _, itemrarity, _, _, _, _, itemstack = GetItemInfo( itemlink )
				if itemname ~= nil and itemstack > 1 and itemrarity ~= nil and itemrarity > 0 then
					if not BankGUI.BankListStock[ itemname ] then BankGUI.BankListStock[ itemname ] = {} end
					if not BankGUI.BankListStock[ itemname ].bagged then BankGUI.BankListStock[ itemname ].bagged = 0 end
					BankGUI.BankListStock[ itemname ].bagged = BankGUI.BankListStock[ itemname ].bagged + itemcount
				end
			end
		end
	end
	for j = 0, 4 do
		for i = 1, GetContainerNumSlots(j) do
			itemlink = GetContainerItemLink(j, i)
			if itemlink then
				_, itemcount = GetContainerItemInfo(j, i)
				itemname, _, itemrarity, _, _, _, _, itemstack = GetItemInfo( itemlink )
				if itemname ~= nil and itemstack > 1 and itemrarity ~= nil and itemrarity > 0 then
					if not BankGUI.BankListStock[ itemname ] then BankGUI.BankListStock[ itemname ] = {} end
					if not BankGUI.BankListStock[ itemname ].bagged then BankGUI.BankListStock[ itemname ].bagged = 0 end
					BankGUI.BankListStock[ itemname ].bagged = BankGUI.BankListStock[ itemname ].bagged + itemcount
				end
			end
		end
	end
	for i = 1, table.getn(BankListCurrency[BankGUI.realmname]) do
		if BankListCurrency[BankGUI.realmname][i].name == BankGUI.playername then
			if not BankGUI.BankListStock[ BankListCurrency[BankGUI.realmname][i].item ] then BankGUI.BankListStock[ BankListCurrency[BankGUI.realmname][i].item ] = {} end
			if not BankGUI.BankListStock[ BankListCurrency[BankGUI.realmname][i].item ].stock then BankGUI.BankListStock[ BankListCurrency[BankGUI.realmname][i].item ].stock = 0 end
			BankGUI.BankListStock[ BankListCurrency[BankGUI.realmname][i].item ].stock = BankGUI.BankListStock[ BankListCurrency[BankGUI.realmname][i].item ].stock + BankListCurrency[BankGUI.realmname][i].amount
		end
	end
	for i = 1, table.getn(BankListFarms[BankGUI.realmname]) do
		itemname, _, _, _, _, _, _, itemstack = GetItemInfo(BankListFarms[BankGUI.realmname][i].item)
		if itemname == nil and BankListFarms[BankGUI.realmname][i].item ~= nil then
			itemname = BankListFarms[BankGUI.realmname][i].item
			itemstack = 20
		end
		if itemname and itemstack > 1 then
			if not BankGUI.BankListStock[ itemname ] then BankGUI.BankListStock[ itemname ] = {} end
			if not BankGUI.BankListStock[ itemname ].farm then BankGUI.BankListStock[ itemname ].farm = {} end
			if not BankGUI.BankListStock[ itemname ].farm.amount then BankGUI.BankListStock[ itemname ].farm.amount = 0 end
			if not BankGUI.BankListStock[ itemname ].farm.date then BankGUI.BankListStock[ itemname ].farm.date = BankListFarms[BankGUI.realmname][i].date end
			BankGUI.BankListStock[ itemname ].farm.amount = BankGUI.BankListStock[ itemname ].farm.amount + BankListFarms[BankGUI.realmname][i].amount
			if BankListFarms[BankGUI.realmname][i].date < BankGUI.BankListStock[ itemname ].farm.date then BankGUI.BankListStock[ itemname ].farm.date = BankListFarms[BankGUI.realmname][i].date end
			BankGUI.BankListStock[ itemname ].farm.name = BankListFarms[BankGUI.realmname][i].name
		end
	end
end


function BankGUI:On_Variables_Loaded()
	local playerinfo = { name = "", money = 0, faction = UnitFactionGroup("player") }
	local optionsinfo = { detach = false, guild_checked = false, guild_name = nil, player_name = nil, player_type = 1, [BANKGUI_HOOVER] = false }
	local i, element_exists, subarray, subsubarray = 0, false

	BankGUI.realmname = GetRealmName()
	BankGUI.playername = UnitName("player")
	BankGUI.playerfaction = UnitFactionGroup("player")
	--if not BankListOptions then BankListOptions = {} end
	if not BankListOptions[BankGUI.realmname] then BankListOptions[BankGUI.realmname] = {} end
	if not BankListOptions[BankGUI.realmname][1] then
		table.insert( BankListOptions[BankGUI.realmname], optionsinfo )
	end

	if BankListOptions[BankGUI.realmname][1].detach == nil then BankListOptions[BankGUI.realmname][1].detach = false end
	-- Remove the following line after fix attach to FriendsFrame
	--BankListOptions[BankGUI.realmname][1].detach = true
	-- end remove
	if BankListOptions[BankGUI.realmname][1][BANKGUI_FACTION] == nil then BankListOptions[BankGUI.realmname][1][BANKGUI_FACTION] = false end
	if BankListOptions[BankGUI.realmname][1][BANKGUI_TOTALS] == nil then BankListOptions[BankGUI.realmname][1][BANKGUI_TOTALS] = false end
	if BankListOptions[BankGUI.realmname][1][BANKGUI_HOOVER] == nil then BankListOptions[BankGUI.realmname][1][BANKGUI_HOOVER] = false end

	for subarray in pairs(BankGUI.BANKGUI_OPTIONS_MENU) do
		if subarray == BANKGUI_KEEPTRACKOF then
			if not BankListOptions[BankGUI.realmname][1][ subarray ] then BankListOptions[BankGUI.realmname][1][ subarray ] = {} end
			for subsubarray in pairs(BankGUI.BANKGUI_OPTIONS_MENU[ subarray ]) do
				if BankListOptions[BankGUI.realmname][1][ subarray ][ subsubarray ] == nil then BankListOptions[BankGUI.realmname][1][ subarray ][ subsubarray ] = true end
			end
		end
		if string.find(subarray, "Sort Order") ~= nil then
			if not BankListOptions[BankGUI.realmname][1][subarray] then BankListOptions[BankGUI.realmname][1][subarray] = {} end
			if not BankListOptions[BankGUI.realmname][1][subarray].name then
				if subarray == BANKGUI_SORTTITLE1 then BankListOptions[BankGUI.realmname][1][subarray].name = BANKGUI_SORTNAME1 end
				if subarray == BANKGUI_SORTTITLE2 then BankListOptions[BankGUI.realmname][1][subarray].name = BANKGUI_SORTNAME2 end
				if subarray == BANKGUI_SORTTITLE3 then BankListOptions[BankGUI.realmname][1][subarray].name = BANKGUI_SORTNAME3 end
			end
		end
	end
	for i = 1, table.getn(BankGUI.BANKGUI_OPTIONS_MENU) do
		if BankGUI.BANKGUI_OPTIONS_MENU[i].name ~= nil then
			if BankGUI.BANKGUI_OPTIONS_MENU[i].checkable == true then
				if BankListOptions[BankGUI.realmname][1][ BankGUI.BANKGUI_OPTIONS_MENU[i].name ] == nil then
					BankListOptions[BankGUI.realmname][1][ BankGUI.BANKGUI_OPTIONS_MENU[i].name ] = false
				end
			end
		end
	end

	BankGUI.TypesIndex = BankListOptions[BankGUI.realmname][1].player_type

	if not BankListGuildInfo then BankListGuildInfo = {} end
	if not BankListGuildInfo[BankGUI.realmname] then BankListGuildInfo[BankGUI.realmname] = {} end

	if not BankListGuildItems then BankListGuildItems = {} end
	if not BankListGuildItems[BankGUI.realmname] then BankListGuildItems[BankGUI.realmname] = {} end

	if BankListFriends == nil then BankListFriends = {} end
	if BankListFriends[BankGUI.realmname] == nil then BankListFriends[BankGUI.realmname] = {} end

	playerinfo["name"] = BankGUI.playername
	playerinfo["money"] = GetMoney()

	if not BankGUI.BankFilter then BankGUI.BankFilter = {} end
	--if not BankGUI.BankFilter[BankGUI.realmname] then BankGUI.BankFilter[BankGUI.realmname] = {} end
	if not BankGUI.BankTotals then BankGUI.BankTotals = {} end
	if not BankListItems then BankListItems = {} end
	if not BankListItems[BankGUI.realmname] then BankListItems[BankGUI.realmname] = {} end
	if not BankListPlayers then BankListPlayers = {} end
	if not BankListPlayers[BankGUI.realmname] then BankListPlayers[BankGUI.realmname] = {} end
	if BankGUI.playername then
		element_exists = false
		for i = 1, table.getn(BankListPlayers[BankGUI.realmname]) do
			if BankListPlayers[BankGUI.realmname][i].name == BankGUI.playername then
				BankListPlayers[BankGUI.realmname][i].money = GetMoney()
				BankListPlayers[BankGUI.realmname][i].faction = BankGUI.playerfaction
				element_exists = true
			end
			if not BankGUI.BankFactionColors[ BankListPlayers[BankGUI.realmname][i].name ] then BankGUI.BankFactionColors[ BankListPlayers[BankGUI.realmname][i].name ] = {} end
			BankGUI.BankFactionColors[ BankListPlayers[BankGUI.realmname][i].name ].faction = UNKNOWN
			if BankListPlayers[BankGUI.realmname][i].faction then
				BankGUI.BankFactionColors[ BankListPlayers[BankGUI.realmname][i].name ].faction = BankListPlayers[BankGUI.realmname][i].faction
			else
				BankGUI.BankFactionColors[ BankListPlayers[BankGUI.realmname][i].name ].faction = UNKNOWN
			end
		end
		if not element_exists then
			table.insert( BankListPlayers[BankGUI.realmname], playerinfo )
			table.sort( BankListPlayers[BankGUI.realmname], function(a, b) return a.name < b.name end )
		end
		local wispinfo = { name = UnitName("player") }
		table.insert(BankGUI.Wisp_Data, wispinfo)
	end

	if not BankListOptions[BankGUI.realmname][1].RunOnceConvert then
		BankGUI:Convert()
		BankListOptions[BankGUI.realmname][1].RunOnceConvert = true
	end

	BankGUI:InsertUI()

	if BankListOptions[BankGUI.realmname][1].detach and BankListOptions[BankGUI.realmname][1].pos then
		BankGUIFrame:SetPoint(BankListOptions[BankGUI.realmname][1].pos.point, "UIParent", BankListOptions[BankGUI.realmname][1].pos.relativePoint, BankListOptions[BankGUI.realmname][1].pos.xOfs, BankListOptions[BankGUI.realmname][1].pos.yOfs)
	end

	BankGUIDetachCheckButton:SetChecked(BankListOptions[BankGUI.realmname][1].detach)
	BankGUIGuildCheckButton:SetChecked(BankListOptions[BankGUI.realmname][1].guild_checked)
	BankGUIGuildCheckButton_OnClick(BankGUIGuildCheckButton)

	BankGUI:SetBankGUIBarColor()
	BankGUI:SetBankFrameBackGround()

end


function BankGUI:On_Player_Login()
	local playerinfo = { name = "", money = 0, }
	local i, j, element_exists = 0, 0, false
	BankGUI.realmname = GetRealmName()
	BankGUI.playername = UnitName("player")
	BankGUI.playerfaction = UnitFactionGroup("player")
	if BankGUI.playername then
		playerinfo.name = BankGUI.playername
		playerinfo.money = GetMoney()
		element_exists = false
		for i = 1, table.getn(BankListPlayers[BankGUI.realmname]) do
			if BankListPlayers[BankGUI.realmname][i].name==BankGUI.playername then
				BankListPlayers[BankGUI.realmname][i].money = GetMoney()
				element_exists = true
			end
		end
		if not element_exists then
			table.insert( BankListPlayers[BankGUI.realmname], playerinfo )
			BankListPlayers[BankGUI.realmname][table.getn(BankListPlayers[BankGUI.realmname])].money = GetMoney()
			table.sort( BankListPlayers[BankGUI.realmname], function(a, b) return a.name < b.name end )
		end
	end

	for i = 1, NUM_CHAT_WINDOWS do
		_G["ChatFrame"..i]:HookScript("OnHyperlinkClick", BankGUI_OnHyperlinkClick)
		_G["ChatFrame"..i]:HookScript("OnHyperlinkEnter", BankGUI_OnHyperlinkEnter)
		_G["ChatFrame"..i]:HookScript("OnHyperlinkLeave", BankGUI_OnHyperlinkLeave)
	end
	if _G["FriendsFrame"] then
		_G["FriendsFrame"]:HookScript("OnShow", BankGUI_OnShowFriendsFrame)
	end
	if GameTooltip then
		GameTooltip:HookScript("OnTooltipSetItem",
			function(tooltip, ...)
				if BankGUI.agrogained then return end
				local itemname, itemlink = tooltip:GetItem()
				if itemname == nil then return end
				if BankListOptions[BankGUI.realmname][1][BANKGUI_TOOLTIPS] and BankGUI.BankListStock[itemname] then
					tooltip:AddLine( " " )
					BankGUI:AddTooltip(tooltip, itemname)
				end
				if BankListOptions[BankGUI.realmname][1][BANKGUI_HOOVER] then
					if IsShiftKeyDown() and IsAltKeyDown() then
						if not bank_ahopened then
							BankGUI:ShowTab()
							BankGUIFarmFrame:Show()
							BankGUIFarmItemBox:SetText("")
							BankGUIFarmItemBox:Insert(itemlink)
							BankGUIFarmItemBox:SetCursorPosition(0)
							if BankGUIFarmAmountBox:GetNumber() == 0 then BankGUIFarmAmountBox:Insert("1") end
							BankGUIFarmAmountBox:SetFocus()
						end
					elseif IsAltKeyDown() then
						if not bank_ahopened then
							BankGUI:ShowTab()
							BankGUIFilterTextBox:SetText("")
							BankGUIFilterTextBox:Insert(itemname)
							BankGUIFilterTextBox:SetCursorPosition(0)
						end
					end
				elseif IsShiftKeyDown() then
					local itemlevel, itemminlevel
					_, _, _, itemlevel, itemminlevel = GetItemInfo(itemlink)
					if itemlevel == nil then itemlevel = 0 end
					if itemminlevel == nil then itemminlevel = 0 end
					tooltip:AddLine( " " )
					tooltip:AddLine( format("|cffff8000MinLvl / Lvl|r |cffffffff%i / %i|r", itemminlevel, itemlevel) )
				end
			end
		)
	end

	BankGUI:UpdateFriends()
	BankGUI:UpdateGlyphs()
	BankGUI:UpdateStock()
end


--[[
function BankGUI:On_Player_Logout()
	if not BankListOptions[BankGUI.realmname][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPPROFS] then return end
	local profs = { GetProfessions() }
	local i, j, found, trade_skill, trade_link
	for j = 1, #profs do
		if profs[j] then
			local tradeinfo= {}
			trade_skill = GetProfessionInfo(profs[j])
			CURRENT_TRADESKILL = trade_skill
			trade_link  = GetTradeSkillListLink(profs[j])
			print(trade_skill..": "..(trade_link or "nil"))
			found = false
			for i = 1, table.getn(BankListItems[BankGUI.realmname]) do
				if BankListItems[BankGUI.realmname][i].type == BANKGUI_TYPE_TRADELINK and BankListItems[BankGUI.realmname][i].name == BankGUI.playername and string.find(BankListItems[BankGUI.realmname][i].item, trade_skill) ~= nil then
					BankListItems[BankGUI.realmname][i].item = trade_link
					BankListItems[BankGUI.realmname][i].amount = date("%d/%m/%y %H:%M")
					found = true
				end
			end
			if not found then
				tradeinfo["type"] = BANKGUI_TYPE_TRADELINK
				tradeinfo["name"] = BankGUI.playername
				tradeinfo["amount"] = date("%d/%m/%y %H:%M")
				tradeinfo["item"] = trade_link
				tradeinfo["bank"] = false
				tradeinfo["faction"] = UnitFactionGroup("player"),
				table.insert(BankListItems[BankGUI.realmname], tradeinfo)
			end
		end
	end
end
--]]

function BankGUI:HandleEvent(self, event, ...)
	local arg1, arg2, arg3, arg4, arg5, arg6 = ...
	--local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20, arg21 = ...

	if event == "VARIABLES_LOADED" then
		BankGUI:On_Variables_Loaded()
		return
	end

	if event == "PLAYER_LOGIN" then
		BankGUI:On_Player_Login()
		return
	end

	--[[
	if event == "PLAYER_LOGOUT" then
		BankGUI:On_Player_Logout()
		return
	end
	--]]

	if event == "PLAYER_MONEY" then
		local bank_gold_tot = 0.0
		BankGUI.playername = UnitName("player")
		for i = 1, table.getn(BankListPlayers[BankGUI.realmname]) do
			if BankListPlayers[BankGUI.realmname][i].name==BankGUI.playername then
				BankListPlayers[BankGUI.realmname][i].money = GetMoney()
			end
			bank_gold_tot = bank_gold_tot + (BankListPlayers[BankGUI.realmname][i].money/10000)
		end
		if not BankListOptions[BankGUI.realmname][1].guild_checked then BankGUITotalGold:SetText( format(BANKGUI_GOLD_BANK,bank_gold_tot) ) end
		return
	end

	if event == "PLAYER_GUILD_UPDATE" then
		local guildinfo = {["name"] = "", ["money"] = 0, }
		local i, element_exists, bank_temp_guildname = 0, false
		bank_temp_guildname = GetGuildInfo("player")
		if BankGUI.guildname and BankGUI.guildname == bank_temp_guildname then return end
		BankGUI.guildname = GetGuildInfo("player")
		if BankGUI.guildname then
			if not BankListGuildItems[BankGUI.realmname][BankGUI.guildname] then BankListGuildItems[BankGUI.realmname][BankGUI.guildname] = {} end
			guildinfo["name"] = BankGUI.guildname
			for i = 1, table.getn(BankListGuildInfo[BankGUI.realmname]) do
				if BankListGuildInfo[BankGUI.realmname][i].name == BankGUI.guildname then element_exists = true end
			end
			if not element_exists then table.insert(BankListGuildInfo[BankGUI.realmname], guildinfo) end
		end
		return
	end

	if event == "PLAYER_REGEN_DISABLED" then
		BankGUI.agrogained = true
		return
	end

	if event == "PLAYER_REGEN_ENABLED" then
		BankGUI.agrogained = false
		return
	end

	if event == "ACTIVE_TALENT_GROUP_CHANGED" then
		BankGUI:UpdateGlyphs()
		BankGUI:UpdateStock()
		if BankGUIFilterTextBox then BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText()) end
		return
	end

	if event == "CURRENCY_DISPLAY_UPDATE" then
		BankGUI:UpdateCurrency()
		BankGUI:UpdateStock()
		if BankGUIFilterTextBox then BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText()) end
		return
	end

	if event == "UPDATE_CHAT_COLOR" then
		if arg1 == "GUILD" then
			BankGUI.guildcolor_on = format("|cff%.2X%.2X%.2X", arg2*255, arg3*255, arg4*255)
			BankGUI.guildcolor_of = format("|cff%.2X%.2X%.2X", arg2*85, arg3*85, arg4*85)
		end
		return
	end

	if event == "BAG_UPDATE" then
		if bank_frame_opened then return end
		if not BankListOptions[BankGUI.realmname][1][BANKGUI_TOOLTIPS] then return end
		if arg1 == -4 then return end
		local subarray, itemlink, itemname, itemcount, itemstack
		for subarray in pairs(BankGUI.BankListStock) do
			BankGUI.BankListStock[ subarray ].bagged = 0
		end
		for j = -2, -2 do
			for i = 1, GetContainerNumSlots(j) do
				itemlink = GetContainerItemLink(j, i)
				if itemlink then
					_, itemcount = GetContainerItemInfo(j, i)
					itemname, _, itemrarity, _, _, _, _, itemstack = GetItemInfo( itemlink )
					if itemname ~= nil and itemstack > 1 and itemrarity ~= nil and itemrarity > 0 then
						if not BankGUI.BankListStock[ itemname ] then
							BankGUI.BankListStock[ itemname ] = {}
							BankGUI.BankListStock[ itemname ].bagged = 0
						end
						BankGUI.BankListStock[ itemname ].bagged = BankGUI.BankListStock[ itemname ].bagged + itemcount
					end
				end
			end
		end
		for j = 0, 4 do
			for i = 1, GetContainerNumSlots(j) do
				itemlink = GetContainerItemLink(j, i)
				if itemlink then
					_, itemcount = GetContainerItemInfo(j, i)
					itemname, _, itemrarity, _, _, _, _, itemstack = GetItemInfo( itemlink )
					if itemname ~= nil and itemstack > 1 and itemrarity ~= nil and itemrarity > 0 then
						if not BankGUI.BankListStock[ itemname ] then
							BankGUI.BankListStock[ itemname ] = {}
							BankGUI.BankListStock[ itemname ].bagged = 0
						end
						BankGUI.BankListStock[ itemname ].bagged = BankGUI.BankListStock[ itemname ].bagged + itemcount
					end
				end
			end
		end
		for subarray in pairs(BankGUI.BankListStock) do
			if BankGUI.BankListStock[ subarray ].bagged and BankGUI.BankListStock[ subarray ].bagged <= 0 then
				BankGUI.BankListStock[ subarray ].bagged = nil
			end
			if BankGUI.BankListStock[ subarray ].stock and BankGUI.BankListStock[ subarray ].stock <= 0 then
				BankGUI.BankListStock[ subarray ].stock = nil
			end
			if BankGUI.BankListStock[ subarray ].bagged == nil and BankGUI.BankListStock[ subarray ].stock == nil and BankGUI.BankListStock[ subarray ].farm == nil then BankGUI.BankListStock[ subarray ] = nil end
		end
		return
	end

	if event == "BANKFRAME_OPENED" then
		bank_frame_opened = true
		if not BankListOptions[BankGUI.realmname][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPITEMS] then return end
		local i, j, k, itemlink, itemcount
		local bank_keepremoving = true
		while bank_keepremoving do
			k = BankGUI:GetBankItemIndexByName(BankGUI.playername)
			if k == 0 then bank_keepremoving = false
			else
				table.remove(BankListItems[BankGUI.realmname], k)
			end
		end
		for j = -2, 11 do
			for i = 1, GetContainerNumSlots(j) do
				itemlink = GetContainerItemLink(j, i)
				_, itemcount = GetContainerItemInfo(j, i)
				if itemlink then
					if j == -1 then
						BankGUI:AddItem(itemlink, itemcount, true, nil, false, j, i)
					else
						BankGUI:AddItem(itemlink, itemcount, true, nil, false, j)
					end
				end
			end
		end
		for i = 1, 19 do
			itemlink = GetInventoryItemLink("player", i)
			if itemlink then BankGUI:AddItem(itemlink, 1, true, "-3", false, nil) end
		end
		BankGUI:SortItems()
		BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText())
		return
	end

	if event == "BANKFRAME_CLOSED" then
		BankGUI:UpdateStock()
		bank_frame_opened = false
		return
	end

	if event == "GUILDBANKFRAME_OPENED" then
		if not BankListOptions[BankGUI.realmname][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPGUILD] then return end
		local i, j, k, itemlink, itemcount
		local guildinfo = {["name"] = "", ["money"] = 0 }
		local element_exists = false
		BankGUI.guildname = GetGuildInfo("player")
		if not BankListGuildItems then BankListGuildItems = {} end
		if not BankListGuildItems[BankGUI.realmname] then BankListGuildItems[BankGUI.realmname] = {} end
		if BankGUI.guildname then
			guildinfo["name"] = BankGUI.guildname
			guildinfo["money"] = GetGuildBankMoney()
			if not BankListGuildInfo then BankListGuildInfo = {} end
			if not BankListGuildInfo[BankGUI.realmname] then BankListGuildInfo[BankGUI.realmname] = {} end
			for i = 1, table.getn(BankListGuildInfo[BankGUI.realmname]) do
				if BankListGuildInfo[BankGUI.realmname][i].name == BankGUI.guildname then
					element_exists = true
					BankListGuildInfo[BankGUI.realmname][i].money = guildinfo["money"]
				end
			end
			if not element_exists then table.insert(BankListGuildInfo[BankGUI.realmname], guildinfo) end
		end
		BankListGuildItems[BankGUI.realmname][BankGUI.guildname] = {}
		for j = 1, GetNumGuildBankTabs() do
			QueryGuildBankTab(j)
			SetCurrentGuildBankTab(j)
			for i = 1, 98 do
				itemlink = GetGuildBankItemLink(j, i)
				_, itemcount = GetGuildBankItemInfo(j, i)
				if itemlink then BankGUI:AddItem(itemlink, itemcount, true, nil, true, j) end
			end
		end
		table.sort( BankListGuildItems[BankGUI.realmname][BankGUI.guildname],
			function(a, b)
				local nA = GetItemInfo(a.item)
				local nB = GetItemInfo(b.item)
				return nA < nB
			end
		)
		BankGUIGuildCheckButton_OnClick(BankGUIGuildCheckButton)
		return
	end

	if event == "TRADE_SKILL_SHOW" then
		local islinked, i, j, k
		islinked, bank_tradeskill_name = IsTradeSkillLinked()
		if islinked then
			if BankListOptions[BankGUI.realmname][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPPROFS] then
				if bank_tradeskill_prof then
					local dialog = "ADD_PROFESSION"
					StaticPopupDialogs[dialog] = {
						text = "Do you want to |cffcccc22ADD|r profession %s from |cff22ff22%s|r to the list ?",
						button1 = "Yes",
						button2 = "No",
						OnAccept = function()
							BankGUI_TradeSkillAdd_OnYes()
						end,
						timeout = 0,
						whileDead = 1,
						which = "",
						showAlert = 1,
						hideOnEscape = 1
					}
					for i = 1, table.getn(BankListItems[BankGUI.realmname]) do
						if BankListItems[BankGUI.realmname][i].type == BANKGUI_TYPE_TRADELINK and BankListItems[BankGUI.realmname][i].name == bank_tradeskill_name and string.find(BankListItems[BankGUI.realmname][i].item, bank_tradeskill_titl) ~= nil then
							_, j = string.find(bank_tradeskill_prof, "trade:")
							k, _ = string.find(bank_tradeskill_prof, "|h")
							if BankListItems[BankGUI.realmname][i].item == bank_tradeskill_prof then
								return
							else
								StaticPopupDialogs[dialog].text = "Do you want to |cffcccc22UPDATE|r profession %s from |cff22ff22%s|r to the list ?"
							end
						end
					end
					StaticPopup_Show(dialog, bank_tradeskill_prof, bank_tradeskill_name)
				end
			end
			return
		end
		if not BankListOptions[BankGUI.realmname][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPTRADE] then return end
		local sName, sType, itemlink
		for i = 1, GetNumTradeSkills() do
			sName, sType = GetTradeSkillInfo(i)
			if sName and sType ~= "header" then
				itemlink = GetTradeSkillRecipeLink(i)
				if not BankGUI:GetSkillItemByName(itemlink, sType) then BankGUI:AddItem(itemlink, 1, false, sType, false, nil) end
			end
		end
		BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText())
		return
	end

	if event == "CHAT_MSG_WHISPER" then
		local wispinfo = { ["name"] = arg2 }
		local i, element_exists = 1, false
		for i = 1, table.getn(BankGUI.Wisp_Data) do
			if BankGUI.Wisp_Data[i].name == arg2 then
				element_exists = true
				break
			end
		end
		if not element_exists then
			table.insert(BankGUI.Wisp_Data, wispinfo)
			table.sort(BankGUI.Wisp_Data,
				function(a, b)
					if a.name==nil or b.name==nil then
						return false
					else
						return a.name < b.name
					end
				end
			)
		end
		if string.sub(arg1, 1, 1) == "!" and string.len(arg1) > 1 then
			local craftable = string.lower( string.sub(arg1, 2) )
			local j, subarray = 0
			for subarray in pairs(BankGUI.BankListStock) do
				if string.find(string.lower(subarray), craftable) ~= nil then
					if j < 10 then SendChatMessage( format("[%s]x%i", subarray, BankGUI.BankListStock[subarray].stock), "WHISPER", nil, arg2)
					else
						SendChatMessage("--- Too many items found. Listing is stopped. ---", "WHISPER", nil, arg2)
						break
					end
					j = j + 1
				end
			end
		end
		return
	end

	if event == "CHAT_MSG_SYSTEM" then
		if arg6 ~= nil and arg6 == "MOTD" then return end
		if arg1 ~= nil then
			local bank_friend_name, bank_friend_level, bank_friend_class, bank_friend_note, bank_fl_name
			local i, j = string.find(arg1, "|Hplayer")
			if i ~= nil then
				i = string.find(arg1, "[[]", j)
				i = i + 1
				_, j = string.find(arg1, "[]]", i)
				j = j - 1
				if string.sub(arg1, i, j) == BankGUI.playername then return end
				bank_fl_name = string.sub(arg1, i, j)
				if BankListFL[bank_fl_name] ~= nil then
					ShowFriends()
					for i = 1, GetNumFriends() do
						bank_friend_name, bank_friend_level, bank_friend_class, _, _, _, bank_friend_note = GetFriendInfo(i)
						if bank_friend_name == bank_fl_name then
							for j = 1, table.getn(BankListFriends[BankGUI.realmname]) do
								if BankListFriends[BankGUI.realmname][j].name == bank_fl_name then
									if BankListFriends[BankGUI.realmname][j].level ~= bank_friend_level then
										BankListFriends[BankGUI.realmname][j].level = bank_friend_level
										BankListFL[bank_fl_name].level = bank_friend_level
									end
									if BankListFriends[BankGUI.realmname][j].class ~= bank_friend_class then
										BankListFriends[BankGUI.realmname][j].class = bank_friend_class
										BankListFL[bank_fl_name].class = bank_friend_class
									end
									if BankListFriends[BankGUI.realmname][j].note ~= nil and BankListFriends[BankGUI.realmname][i].note ~= bank_friend_note then
										BankListFriends[BankGUI.realmname][j].note = bank_friend_note
										BankListFL[bank_fl_name].note = bank_friend_note
									end
								end
							end
							return
						end
					end
				end
			end
		end
		return
	end

--[[
	if event == "CHAT_MSG_BN_WHISPER" then
		if arg1 ~= nil then BankGUI.chat:AddMessage("arg1: " ..tostring(arg1)) end
		if arg2 ~= nil then BankGUI.chat:AddMessage("arg2: " ..tostring(arg2)) end
		if arg3 ~= nil then BankGUI.chat:AddMessage("arg3: " ..tostring(arg3)) end
		if arg4 ~= nil then BankGUI.chat:AddMessage("arg4: " ..tostring(arg4)) end
		if arg5 ~= nil then BankGUI.chat:AddMessage("arg5: " ..tostring(arg5)) end
		if arg6 ~= nil then BankGUI.chat:AddMessage("arg6: " ..tostring(arg6)) end
		if arg7 ~= nil then BankGUI.chat:AddMessage("arg7: " ..tostring(arg7)) end
		if arg8 ~= nil then BankGUI.chat:AddMessage("arg8: " ..tostring(arg8)) end
		if arg9 ~= nil then BankGUI.chat:AddMessage("arg9: " ..tostring(arg9)) end
		local target = BNTokenCombineGivenAndSurname(arg2)
		local presenceID = BNet_GetPresenceID(target)
		BNSendWhisper(presenceID, "RealID whisper autoresponse gelukt !")
	end
--]]

	if event == "AUCTION_HOUSE_CLOSED" then
		bank_ahopened = false
		return
	end

	if event == "AUCTION_HOUSE_SHOW" then
		bank_ahopened = true
		return
	end

end


local bank_endtext = "|cffff8000"..BANKGUI_TITLE .."|r End."

function BankGUI:Bank_SlashCommandHandler(msg)

	if msg == nil or msg == "" then
		BankGUI:ToggleTab()
	elseif msg == "help" or msg == "?" then
		local i
		BankGUI.chat:AddMessage(" ")
		for i = 1, #BANKGUI_HELP do
			BankGUI.chat:AddMessage(BANKGUI_HELP[i][1], BANKGUI_HELP[i][2], BANKGUI_HELP[i][3], BANKGUI_HELP[i][4])
		end
		BankGUI.chat:AddMessage(string.format(" |cffffff80%s, %s, %s|r", BankListOptions[BankGUI.realmname][1][BANKGUI_SORTTITLE1].name, BankListOptions[BankGUI.realmname][1][BANKGUI_SORTTITLE2].name, BankListOptions[BankGUI.realmname][1][BANKGUI_SORTTITLE3].name))
		BankGUI.chat:AddMessage(" ")
		BankGUI.chat:AddMessage( string.format("Memory: %.2f Mb", (GetAddOnMemoryUsage("BankGUI"))/1000.0), BANKGUI_HELP[2][2], BANKGUI_HELP[2][3], BANKGUI_HELP[2][4])
	elseif msg == "update" then
		BankGUI:UpdateCurrency()
		BankGUI:UpdateFriends()
		BankGUI:UpdateGlyphs()
		BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText())
	elseif msg == "detach" then
		BankGUIDetachCheckButton:SetChecked(true)
		BankGUIDetachCheckButton_OnClick()
	elseif msg == "attach" then
		BankGUIDetachCheckButton:SetChecked(false)
		BankGUIDetachCheckButton_OnClick()
	elseif msg == "sort" then
		BankGUI:SortItems()
	elseif msg == "check" then
		local count, i, j, itemname, itemlink, itemcount, itemstack = 0
		local bank_stackcheck = {}
		BankGUI.chat:AddMessage( "|cffff8000"..BANKGUI_TITLE .."|r Stack Check...")
		for j = -2, 11 do
			for i = 1, GetContainerNumSlots(j) do
				itemlink = GetContainerItemLink(j, i)
				if itemlink then
					_, itemcount = GetContainerItemInfo(j, i)
					itemname, _, _, _, _, _, _, itemstack = GetItemInfo(itemlink)
					if itemstack and itemstack > 1 and itemcount < itemstack then
						if not bank_stackcheck[itemname] then
							bank_stackcheck[itemname] = {}
							bank_stackcheck[itemname].s = itemstack
							bank_stackcheck[itemname].c = itemcount
						else
							if j >=0 and j<= 4 then BankGUI.chat:AddMessage( "BAGS: " ..itemlink)
							else BankGUI.chat:AddMessage( "BANK: " ..itemlink)
							end
							count = count + 1
						end
					end
				end
			end
		end
		bank_stackcheck = {}
		for j = -2, 4 do
			for i = 1, GetContainerNumSlots(j) do
				itemlink = GetContainerItemLink(j, i)
				if itemlink then
					_, itemcount = GetContainerItemInfo(j, i)
					itemname, _, _, _, _, _, _, itemstack = GetItemInfo(itemlink)
					if itemstack and itemstack > 1 and itemcount < itemstack then
						if not bank_stackcheck[itemname] then
							bank_stackcheck[itemname] = {}
							bank_stackcheck[itemname].s = itemstack
							bank_stackcheck[itemname].c = itemcount
						end
					end
				end
			end
		end
		for j = 1, GetNumGuildBankTabs() do
			SetCurrentGuildBankTab(j)
			QueryGuildBankTab(j)
			for i = 1, 98 do
				itemlink = GetGuildBankItemLink(j, i)
				if itemlink then
					_, itemcount = GetGuildBankItemInfo(j, i)
					itemname, _, _, _, _, _, _, itemstack = GetItemInfo(itemlink)
					if itemstack and itemstack > 1 and itemcount < itemstack then
						if not bank_stackcheck[itemname] then
							bank_stackcheck[itemname] = {}
							bank_stackcheck[itemname]["s"] = itemstack
							bank_stackcheck[itemname]["c"] = itemcount
						else
							BankGUI.chat:AddMessage( " GUILDBANK (tab " ..j .."): " ..itemlink)
							count = count + 1
						end
					end
				end
			end
		end
		if count == nil then BankGUI.chat:AddMessage( " No stacks found that aren't maximized." ) end
		BankGUI.chat:AddMessage( bank_endtext )
	elseif msg == "grey" then
		local i, j, itemlink, itemrarity
		BankGUI.chat:AddMessage( "|cffff8000"..BANKGUI_TITLE .."|r Grey Item Check...")
		for j = -2, 11 do
			for i = 1, GetContainerNumSlots(j) do
				itemlink = GetContainerItemLink(j, i)
				if itemlink then
					_, _, itemrarity = GetItemInfo(itemlink)
					if itemrarity <= 0 then
						BankGUI.chat:AddMessage( format("|cffff8000%s|r %s", BANKGUI_TITLE, itemlink) )
					end
				end
			end
		end
		for j = 1, GetNumGuildBankTabs() do
			SetCurrentGuildBankTab(j)
			QueryGuildBankTab(j)
			for i = 1, 98 do
				itemlink = GetGuildBankItemLink(j, i)
				if itemlink then
					_, _, itemrarity = GetItemInfo(itemlink)
					if itemrarity <= 0 then
						BankGUI.chat:AddMessage( format("|cffff8000%s|r (tab %i) %s", BANKGUI_TITLE, j, itemlink) )
					end
				end
			end
		end
		BankGUI.chat:AddMessage( bank_endtext )
	elseif string.find(msg, "|Hitem") then
		msg = GetItemInfo(msg)
		BankGUIFilterTextBox:SetText(msg)
		BankGUI:ToggleTab()
	else
		BankGUIFilterTextBox:SetText(msg)
		BankGUI:ToggleTab()
	end
end
