
local Item_NoDelete = {
	["-4"] = "TradeLink",
}

function BankGUI:AddItem(itemname, amnt, banked, itemtype, guild, bagid, slotnumber)
	local bankinfo
	-- handle item
	if (itemname == nil) then return end
	-- handle amount
	if (amount == nil) then amount = 1 end
	-- handle bank/skill item
	if (banked == nil) then banked = true end

	if (itemtype == nil and bagid ~= nil) then
		itemtype = "" ..bagid
	end

	if (guild == nil) then guild = false end

	if guild then
		bankinfo = {item = itemname, amount = amnt, type = bagid}
		table.insert(BankListGuildItems[BankGUI.realmname][BankGUI.guildname], bankinfo)
	else
		bankinfo = {name = BankGUI.playername, item = itemname, amount = amnt, bank = banked, type = itemtype, slot = slotnumber}
		table.insert(BankListItems[BankGUI.realmname], bankinfo)
	end
end


function BankGUI:GetNumGuilds()
	if not BankListGuildInfo then return 0 end
	if not BankListGuildInfo[BankGUI.realmname] then return 0 end
	return table.getn(BankListGuildInfo[BankGUI.realmname])
end


function BankGUI:GetGuild(index)
	if not BankListGuildInfo[BankGUI.realmname] then return ""
	elseif BankListGuildInfo[BankGUI.realmname][index] then return BankListGuildInfo[BankGUI.realmname][index].name
	else return "" end
end


-- Returns the number of players in list
function BankGUI:GetNumItems()
	return table.getn(BankGUI.BankFilter)
end


function BankGUI:GetBankItemIndexByName(name)
	local i
	for i = 1, table.getn(BankListItems[BankGUI.realmname]) do
		if ( BankListItems[BankGUI.realmname][i].name == name and Item_NoDelete[ BankListItems[BankGUI.realmname][i].type ] == nil ) then return i end
	end
	return 0
end


function BankGUI:GetSkillItemByName(item, type)
	local i
	for i = 1, table.getn(BankListItems[BankGUI.realmname]) do
		if BankListItems[BankGUI.realmname][i].bank == false and BankListItems[BankGUI.realmname][i].item == item then
			if type ~= "header" then BankListItems[BankGUI.realmname][i].type = type end
			if string.find( BankListItems[BankGUI.realmname][i].name, BankGUI.playername ) == nil then
				BankListItems[BankGUI.realmname][i].name = BankListItems[BankGUI.realmname][i].name .."," ..BankGUI.playername
			end
			return true
		 end
	end
	return false
end


-- Returns the player object given by index
function BankGUI:GetItemByIndex(index)

	if (index < 1 or index > self:GetNumItems()) then
		return nil
	end

	return BankGUI.BankFilter[index]

end
